%GAITGESTURES.M will allow the user to adjust the gait gestures for a
% given gait.
%
%Use: load fourstrokegait, gaitgestures(fourstrokegait(:,[1+[9,11,1]]));
%NOTE: Development on this stopped because of J. Karpick's GestureTweak
%software. (~03/18/06 -TM) 
%  http://bdml.stanford.edu/twiki/bin/view/Main/GestureTweak
%NOTE: This was based on INTERACTIVE_MOVE.M ("Click-n'-drag plot")
%  http://www.mathworks.com/matlabcentral/fileexchange/loadFile.do?objectId=5751&objectType=scoreDetails

function dataout=gaitgestures(datain)

%Get some basic info
N=size(datain,1);
n=1:N;

%Create the generic plot (based on leg#0)
h0=figure;
subplot(3,1,1)
h(1)=plot(n,datain(:,1));, grid on, ylabel('Servo CMD [steps]')
setplotclick
subplot(3,1,2)
h(2)=plot(n,datain(:,2));, grid on, ylabel('Servo CMD [steps]')
setplotclick
subplot(3,1,3)
h(3)=plot(n,datain(:,3));, grid on, ylabel('Servo CMD [steps]')
setplotclick
xlabel('Sequence Frame No.')
%fullscreen(h1);        %Doesn't work well w/Unix (03/17/06 -TM)

%Add DATAIN to handles
handles=guidata(gcf);
handles.h=h;
handles.datain=datain;
handles.macro_active=0;

%Store the handle data
    guidata(gcf,handles);


%Close the figure
%close(h0);


function setplotclick(gca)
set(gcf, 'windowbuttondownfcn', {@clickplot,1});
set(gcf, 'windowbuttonmotionfcn', {@clickplot,2});
set(gcf, 'windowbuttonupfcn', {@clickplot,3});
set(gcf, 'keypressfcn', {@clickplot,4});



function clickplot(h,event,type)

handles=guidata(gca);
N=size(handles.datain,1);
h=handles.h;

switch type

    case 1 %---Mouse Button down
        out=round(get(gca,'CurrentPoint'));
        handles.lineObj=[findobj(gca, 'Type', 'line');findobj(gca, 'Type', 'patch')];
        handles.currentTitle=get(get(gca, 'Title'), 'String');
        set(gca,'NextPlot','replace')
        set(gcf,'Pointer','fullcrosshair');
        handles.macro_active=1;
        handles.xpos=out(1,1);%--store initial position x
        handles.ypos=out(1,2);%--store initial position y
        xl=get(gca,'XLim');yl=get(gca,'YLim');
        if ((handles.xpos > xl(1) & handles.xpos < xl(2)) & (handles.ypos > yl(1) & handles.ypos < yl(2))) %--disable if outside axes
            %[handles.currentlineObj,handles.currentlinestyle]=line_pickup(handles.lineObj,[out(1,1) out(1,2)]);%--choose the right curve via line_pickup
            %if handles.currentlineObj~=0 %--if curve foundd
            handles.xData = get(handles.lineObj, 'XData');%--assign x data
            handles.yData = get(handles.lineObj, 'YData');%--assign y data
            %end
            handles.currentTitle=get(get(gca, 'Title'), 'String');
        end

        %Store the handle data
        guidata(gca,handles)

    case 2 %---Mouse Button Down and Moving
        if handles.macro_active
            out=round(get(gca,'CurrentPoint'));
            handles.xpos=out(1,1);%--store initial position x
            handles.ypos=out(1,2);%--store initial position y
            set(gcf,'Pointer','fullcrosshair');
            title(['[Frame,Servo CMD] : [' num2str(out(1,1)) ',' num2str(out(1,2)) ']']);

%            if handles.currentlineObj~=0
%                 %Find the axis clicked
%                 ax=0;
%                 for i=1:3
%                     if gca==h(i)
%                         ax=i;
%                     end
%                 end
                %Set the new data value
                handles.yData(handles.xpos)=handles.ypos;
                set(handles.lineObj,'YData',handles.yData);%--change y data
                title(['[[Frame,Servo CMD] : [' num2str(out(1,1)) ',' num2str(out(1,2)) ']']);
%            end
            %Store the handle data
            guidata(gca,handles)
        end
    
    case 3 %----Mouse Button up (cleanup some variable)
        handles.macro_active=0;
        title(handles.currentTitle);
        set(gcf,'Pointer','arrow');
        set(gca,'NextPlot','add');
        handles.key='';
        %Store the handle data
        guidata(gca,handles)
    
    case 4 %----Keyboard key press
        handles.key=get(gcf,'CurrentCharacter');
        %Store the handle data
        guidata(gca,handles)
        if (handles.key=='x')
            close;
        end
end

%%%%%%%%%%%%%%%%%%%%%
%%%   TODO LIST   %%%
%%%%%%%%%%%%%%%%%%%%%
% Add bounds to input y [0 255]
% Get the ydata for each axis/subplot (figure out how to access all axes)
% Put all ydata into DATAOUT variable
% Add legend for keystrokes (Exit, Copy to all/side/front/rear/leg num/etc)
% OR Add buttons to Exit, Copy to all/side/front/rear/leg num/etc
%
